/* 
   Platform specific code for DEC alpha-osf1
   Author: Alexander Kogan, <kogan@ptc.com>, <kogan@iname.com>
*/

#ifdef __osf__

/*
typedef struct {
	char	name[5];
	int		his[55];
	int		hisaddcnt;
	long	rt_stat;
	long	statlast;
	long	rt_idle;
	long	idlelast;
} stat_dev;
*/

#include <time.h>
#include <sys/table.h>
#include <sys/vm.h>
#include <mach/vm_statistics.h>

/* ------------------------------------------------------------------------- */
void osf1_init(void)
{
}

/* ------------------------------------------------------------------------- */
long osf1_online_time()
{
    struct tbl_sysinfo sibuf;

    if (table(TBL_SYSINFO,0,&sibuf,1,sizeof(struct tbl_sysinfo))<0)
    {
	perror("TBL_SYSINFO - boottime");
        sibuf.si_boottime = 0;
    }

    return time(0) - sibuf.si_boottime;
}

/* ------------------------------------------------------------------------- */
void update_stat_mem(stat_dev *st, stat_dev *st2)
{
    struct tbl_swapinfo swbuf;
    vm_statistics_data_t vmbuf;


    vm_statistics(task_self(), &vmbuf);

    st->rt_stat = vmbuf.active_count>>10;
    st->rt_idle = (vmbuf.free_count + vmbuf.active_count +
                   vmbuf.inactive_count + vmbuf.wire_count)>>10;

    if ( table(TBL_SWAPINFO,-1,&swbuf,1,sizeof(struct tbl_swapinfo))>0 ) 
    {
        st2->rt_idle = swbuf.size>>10;
        st2->rt_stat = (swbuf.size - swbuf.free)>>10;
    }
}

/* ------------------------------------------------------------------------- */
void get_statistics(char *devname, long *is, long *ds, long *idle)
{
    
    *is = *ds = *idle = 0;

    if ( !strncmp(devname, "cpu", 3) ) 
    {
        struct tbl_sysinfo sibuf;
        struct tbl_loadavg labuf;

        if ( table(TBL_SYSINFO,0,&sibuf,1,sizeof(struct tbl_sysinfo) ) > 0 )
        {
            *ds   = sibuf.si_user + sibuf.si_nice + sibuf.si_sys;
            *idle = sibuf.si_idle;
        }
        else
            perror("TBL_SYSINFO");

        if ( table(TBL_LOADAVG,0,&labuf,1,sizeof(struct tbl_loadavg) ) > 0 )
        {
            if ( labuf.tl_lscale )   /* scaled */
                *is = (labuf.tl_avenrun.l[0] + 
					   labuf.tl_avenrun.l[1] + 
					   labuf.tl_avenrun.l[2])/(labuf.tl_lscale/10);
            else
                *is = (long)(labuf.tl_avenrun.d[0] + 
							 labuf.tl_avenrun.d[1] + 
							 labuf.tl_avenrun.d[2]);
         	/*   *is *= 10; */
        }
        else
            perror("TBL_LOADAVG");
    }
    else if ( !strncmp(devname, "i/o", 3) ) 
    {
        struct tbl_dkinfo dkbuf;
        int i;

        for ( i = 0; i < 10; i++ )
            if (table(TBL_DKINFO,i,&dkbuf,1,sizeof(struct tbl_dkinfo))>0)
            {
                if ( strncmp(dkbuf.di_name, "rz", 2) )
                    continue;
                else 
                    *ds += 100*dkbuf.di_avque + 100*dkbuf.di_avwait + 
                        dkbuf.di_avserv;
            }
    }
}

#endif
